#pragma once
namespace Themis {

class WorkerThreadController;

/**
    J[\̈ړsIuWFNgB

    XbhpĊ炩ɁB

    Waitl15`20x(16.666.. == 60FPS)AAccell1`64xɁB
*/
class CCursorMover {
public:
    CCursorMover();
    ~CCursorMover();

    /// J[\݈̌ʒu擾
    CPoint GetPos() const;
    /// ̖ڕWʒuݒ
    void SetPos(CPoint ptScreen);

    /// Waitl̐ݒ
    void SetWait(int nWait) { m_nWait = nWait; }
    /// Waitl̎擾
    int GetWait() const { return m_nWait; }

    /// Accell̐ݒ
    void SetAccel(int nAccel) { m_nAccel = nAccel; }
    /// Accell̎擾
    int GetAccel() const { return m_nAccel; }

    /// J[\͈ړȂ̂
    bool IsMoving() const { return (0 <= m_nFrameCount); }

private:
    virtual void OnThread();

    volatile bool threadValid;
    std::tr1::shared_ptr<WorkerThreadController> thread;
    boost::mutex mutex;
    boost::condition condition;

    int             m_nWait;
    int             m_nAccel;

    CPoint          m_ptOrigin;
    CPoint          m_ptNow;
    CSize           m_szDistance;
    volatile int    m_nFrameCount;
};

}
