#pragma once
namespace Themis {

/**
    rsIuWFNg

    virtual void Lock();
    virtual void Unlock();
*/
class IExclusion : private boost::noncopyable {
public:
    virtual ~IExclusion() {}

    /// Lock() - Unlock()Iɍsׂ̃IuWFNgBNULLȂ珈ȂB
    class CLock : private boost::noncopyable {
    public:
        inline CLock(IExclusion& r) : m_p(&r) { m_p->Lock(); }
        inline CLock(IExclusion* p) : m_p(p) { if (m_p != NULL) { m_p->Lock(); } }
        inline ~CLock() { if (m_p != NULL) { m_p->Unlock(); } }
    private:
        IExclusion*   m_p;
    };

    /// rs
    virtual void Lock() = 0;
    /// r
    virtual void Unlock() = 0;
};

/**
    IExclusionNullDevice
*/
class CNullExclusion : public IExclusion {
public:
    virtual void Lock() {}
    virtual void Unlock() {}
};

}
