#pragma once
#include "Image.h"
namespace Themis {

/*
    ȉ http://www.emit.jp/argb/argb.html KɃRsyB

    ׂ摜tH[}bg ARGB
    xł郿l܂߂邱ƂłAVvȉ摜tH[}bg
    Ȃ̂ŒĂ邱Ƃɂ܂B܂AKvƎvc[쐬܂B

    
    ET|[gĂ`Ȃ߁A[_̍쐬Af[^̃Ro[gAtH[}bg̃T|[gȒPłB
    EɌ܂ŃVvłȂA\ȃLpVeB邽߁AԃtH[}bgƂĎg܂B
    Ee8bit32bitColorƁAe16bit64bitColorɑΉB

    ARGB`̎dl
    gq
        .ARGB
    tH[}bg
        wb_ + sNZf[^
    wb_(16uint8_t)
        typedef struct {
            union {
                // sNZ̕ѕ咣
                BYTE abyIdentifier[4];  // L"BGRA"
                DWORD dwIdentifier;     // 0x41524742
            };
            DWORD dwPixelFormat;        // 0x08080808(32bitColor) or 0x10101010(64bitColor)
            DWORD dwWidth;
            DWORD dwHeight;
        } ArgbHeader;
    sNZf[^
        sNZf[^̑TCÝA4 * dwWidth * dwHeight uint8_tB(64bitColoŕA8 * dwWidth * dwHeight uint8_t)
        esNZf[^́A
        1uint8_tڂ(Blue)̒l
        2uint8_tڂ(Green)̒l
        3uint8_tڂ(Red)̒l
        4uint8_tڂ(Alpha)̒l
        ƂȂ(64bitColor͊e2uint8_t(gGfBA))B
*/

namespace Detail {
    struct SArgbHeader {
        union {
            uint8_t abyIdentifier[4];  // L"BGRA"
            uint32_t dwIdentifier;     // 0x41524742
        };
        uint32_t dwPixelFormat;        // 0x08080808(32bitColor) or 0x10101010(64bitColor)
        uint32_t dwWidth;
        uint32_t dwHeight;
    };
}

/**
    ARGBt@Cǂݍ݃NXB
*/
class CArgbLoader : public IImageLoader {
public:
    bool Load(const std::tr1::shared_ptr<CFileData>& fileData, bool bRenderOnlyAtOnce);
    CSize GetSize() const;
    void Render(CPlane& dst, const CPoint& pt, bool bRenderOnlyAtOnce);
    bool HasAlpha() const { return true; }
    string GetTypeName() const { return L"ARGB"; }
    string GetTypeFileName() const { return L"*.argb"; }

private:
    Detail::SArgbHeader m_oHeader;
    boost::scoped_array<uint32_t>   m_adwPixels;
};

/**
    ARGBt@CoNXB
*/
class CArgbSaver : public IImageSaver {
public:
    void Save(const CFileName& oFileName, const CPlane& src, const CRect& rc);
};

/// ARGBt@Cǂݍ݃NXFactory
typedef DefaultFactory<CArgbLoader, IImageLoader>  CArgbLoaderFactory;

}
