#pragma once
namespace Themis {

class CMsgHookPrms;

/**
    }EXŋ`̈w肷鏈sB

    ȊŎgB

@code

    auto_ptr<CRectSelector> rectSelector;

@endcode@code

    rectSelector.reset(new CRectSelector());

@endcode@code

    rectSelector->SetWindow(m_pWindow->GetHandle());

@endcode@code

    } else if (rPrms.GetMsg() == WM_LBUTTONDOWN) {
        rectSelector->OnButtonDown(m_pDocument->IsReady());
        return true;
    } else if (rPrms.GetMsg() == WM_LBUTTONDBLCLK) {
        rectSelector->OnButtonDown(m_pDocument->IsReady());
        return true;
    } else if (rPrms.GetMsg() == WM_LBUTTONUP) {
        rectSelector->OnButtonUp();
        return true;
    } else if (rPrms.GetMsg() == WM_MOUSEMOVE) {
        rectSelector->OnCursorMove();
        return true;
    } else if (rPrms.GetMsg() == WM_SETCURSOR) {
        return rectSelector->OnSetCursor();

@endcode@code

    } else if (rPrms.GetMsg() == WM_PAINT) {
        std::tr1::shared_ptr<PAINTSTRUCT> ps = m_pWindow->BeginPaint();
        rectSelector->OnPaint(*ps);

@endcode
*/
class CRectSelector : private boost::noncopyable {
public:
    CRectSelector();
    ~CRectSelector();

    /// e̐ݒ
    void SetWindow(HWND hWnd);

    //@{ bZ[W
    void OnButtonDown(bool bEnable);
    void OnButtonUp();
    void OnCursorMove();
    bool OnSetCursor();
    void OnPaint(const PAINTSTRUCT& ps);
    //@}

    //@{ I͈͂̎擾
    bool IsSelected() const { return m_nState1 != 0 && 1 < m_rcSelect.GetWidth() && 1 < m_rcSelect.GetHeight(); }
    const CRect& GetSelect() const { return m_rcSelect; }
    //@}

    /// IԂɂ
    void ClearSelect() { m_nState1 = 0; }

protected:
    /// J[\̍W擾
    CPoint GetCursorPos();
    /// 0:ړA1:EEA2:EEA3:㉺A4:E
    static HCURSOR GetSystemCursor(int nCursor);

private:
    HWND        m_hWnd;
    int         m_nState1;  // 0:IA1:I𒆁A2:TCYA3:ړA4:Iς
    int         m_nState2;  // TCYȏꍇAO珇ɍEEEEEEEEEE
    CPoint      m_ptCursor;
    CPoint      m_ptDragBegin;
    bool        m_bDragMoved;
    CRect       m_rcSelect;
};

}
