#include "stdafx.h"
#include "Windows/Dll.h"
#include "Windows/Registry.h"
#include "SaverAppBase.h"
namespace Themis {

bool CSaverAppBase::IsExitable(HWND hParent) {
    return IsUsePassword()? ShowPassDialog(hParent): true;
}

namespace {
    static void* AtoP(const string& str) {
        intptr_t result = 0;
        int i = 0;
        while (i < str.GetLength() && Char::IsWhiteSpace(str[i])) i++;
        if (i < str.GetLength()) {
            wchar_t sign = str[i];
            if (str[i] == L'+' || str[i] == L'-') i++;
            while (i < str.GetLength() && Char::IsDigit(str[i])) {
                result = result * 10 + (str[i] - L'0');
            }
            if (sign == '-') result = -result;
        }
        return reinterpret_cast<void*>(result);
    }
}
/// ͂āAꂼ̋N[h֕
int CSaverAppBase::InnerRun() {
    if (!IsFirstRun())
        return 0;   //AeĂ̂ˁc
    LPSTR pCmd = GetCmdLine();
    while (*pCmd != L'\0') {
        char c = *pCmd++;
        if (c == L'-' || c == L'/') {
            char c = *pCmd++;
            HWND hParent = static_cast<HWND>(AtoP(Encoding::GetDefault().GetString(pCmd)));
            if (hParent == NULL) {
                hParent = ::GetActiveWindow();
            }
            switch(c) {
            case L'P':
            case L'p': OnPreview(hParent);     break;
            case L'C':
            case L'c': OnConfig(hParent);      break;
            case L'S':
            case L's': OnRunSaver();           break;
            case L'A':
            case L'a': OnSetPassword(hParent); break;
            default:
                break;
            }
        }
    }
    return 0;
}

/// pX[h̕ύX
void CSaverAppBase::OnSetPassword(HWND hParent) {
    CDll(L"MPR.DLL")(L"PwdChangePasswordA", CDllFunc4<int, char*, HWND, int, int>())("SCRSAVE", hParent, 0, 0);
}

/// Z[o[IpX[h͂Kvǂ
bool CSaverAppBase::IsUsePassword() {
    try {
        CRegistry oReg;
        oReg.Open(L"Control Panel\\desktop", false);
        return (0 != oReg.Num(L"ScreenSaveUsePassword"));
    } catch (std::exception&) {
        return false; //vȂɂႤ
    }
}

/// pX[h_CAO\
bool CSaverAppBase::ShowPassDialog(HWND hParent) {
    return (CDll(L"PASSWORD.CPL")(L"VerifyScreenSavePwd", CDllFunc2<BOOL, char*, HWND>())("SCRSAVE", hParent) != FALSE);
}

}
