#include "stdafx.h"
#include "StringBuilder.h"
#include <stdarg.h>
namespace Themis {

StringBuilder& StringBuilder::AppendFormat(const wchar_t* format, ...) {
    va_list argptr;
    va_start(argptr, format);
    int length = _vscwprintf(format, argptr);
    int n = buffer.GetCount();
    buffer.SetCount(n + length + 1); // '\0'̕1m
  #pragma warning(push)
  #pragma warning(disable : 4996)
    vswprintf(&buffer[n], format, argptr);
  #pragma warning(pop)
    va_end(argptr);
    buffer.SetCount(n + length); // ߂Đݒ
    return *this;
}

StringBuilder& StringBuilder::InsertFormat(int index, const wchar_t* format, ...) {
    va_list argptr;
    va_start(argptr, format);
    int length = _vscwprintf(format, argptr);
    std::vector<wchar_t> tmp(length + 1); // '\0'̕1m
  #pragma warning(push)
  #pragma warning(disable : 4996)
    vswprintf(&tmp[0], format, argptr);
  #pragma warning(pop)
    va_end(argptr);
    return Insert(index, tmp, 0, length);
}

}
