#pragma once
namespace Themis {

/**
    CPUID߂gCPU̓𒲂ׂ
*/
class CCpuId : private boost::noncopyable {
public:
    /// CMOV͎gp\Ȃ̂
    static bool IsCMOV() { return IsBit(15); }
    /// MMX͎gp\Ȃ̂
    static bool IsMMX()  { return IsBit(23); }
    /// SSE͎gp\Ȃ̂
    static bool IsSSE()  { return IsBit(25); }
    /// SSE2͎gp\Ȃ̂
    static bool IsSSE2()  { return IsBit(26); }
    /// AMD MMXg͎gp\Ȃ̂
    static bool IsMMXP()  { return IsBitEx(22); }
    /// AMD 3DNow!͎gp\Ȃ̂
    static bool Is3DNow()  { return IsBitEx(31); }
    /// AMD Enhanced 3DNow!͎gp\Ȃ̂
    static bool IsE3DNow()  { return IsBitEx(30); }
    /// nrbgڂ̃tO͗Ă̂
    static bool IsBit(int n) { return (((Get() >> n) & 1) != 0); }
    /// nrbgڂ̃tO͗Ă̂
    static bool IsBitEx(int n) { return (((GetEx() >> n) & 1) != 0); }
    /// ̒l擾(Standard Feature)
    static unsigned Get();
    /// ̒l擾(Extended Feature)
    static unsigned GetEx();
};

}
