#pragma once
#include "NativeString.h"
namespace Themis {

inline LONG_PTR WarnLess_SetWindowLongPtr(HWND hWnd, int nIndex, LONG_PTR dwNewLong) {
  #pragma warning(push)
  #pragma warning(disable : 4244)
    return NativeString::IsUnicode() ?
        ::SetWindowLongPtrW(hWnd, nIndex, dwNewLong) :
        ::SetWindowLongPtrA(hWnd, nIndex, dwNewLong);
  #pragma warning(pop)
}

inline LONG_PTR WarnLess_GetWindowLongPtr(HWND hWnd, int nIndex) {
    return NativeString::IsUnicode() ?
        ::GetWindowLongPtrW(hWnd, nIndex) :
        ::GetWindowLongPtrA(hWnd, nIndex);
}

inline ULONG_PTR WarnLess_SetClassLongPtr(HWND hWnd, int nIndex, LONG_PTR dwNewLong) {
  #pragma warning(push)
  #pragma warning(disable : 4244)
    return NativeString::IsUnicode() ?
        ::SetClassLongPtrW(hWnd, nIndex, dwNewLong) :
        ::SetClassLongPtrA(hWnd, nIndex, dwNewLong);
  #pragma warning(pop)
}

inline ULONG_PTR WarnLess_GetClassLongPtr(HWND hWnd, int nIndex) {
    return NativeString::IsUnicode() ?
        ::GetClassLongPtrW(hWnd, nIndex) :
        ::GetClassLongPtrA(hWnd, nIndex);
}

}
