#pragma once
#include "ImplData.h"
namespace Themis {

/**
    Comma Separated Values

    ǂݏɈ͈ȉ̒ʂƂB

    Es͉sŋ؂Aɂ̓J}͕tȂ
    E̓J}ŋ؂
    EɃJ}s܂߂ꍇ L"`" ł
    EL"`"  L" ܂߂ꍇ "" ƋLq

     ۑ̉sR[hCR+LFƂ
*/
class CCsv { // copyable
public:
    CCsv();
    CCsv(const CFileName& oFileName);
    ~CCsv();

    //@{ ǂݏ
    void Load(const CFileName& oFileName);
    void Save(const CFileName& oFileName);
    void LoadFromStr(const string& strData);
    string SaveToStr();
    //@}

    /// s̎擾
    int GetLineCount() const { return int(m_vctData.size()); }
    //@{ sf[^̎擾
    vector<string>& GetLine(int nLine) { return m_vctData[nLine]; }
    const vector<string>& GetLine(int nLine) const { return m_vctData[nLine]; }
    //@}

    /// ws̗񐔂̎擾
    int GetRowCount(int nLine) const { return int(m_vctData[nLine].size()); }
    //@{ wswڂ̃f[^̎擾
    string& Get(int nLine, int nRow) { return m_vctData[nLine][nRow]; }
    const string& Get(int nLine, int nRow) const { return m_vctData[nLine][nRow]; }
    //@}

    //@{ f[^̎擾
    vector<vector<string> >& GetData() { return m_vctData; }
    const vector<vector<string> >& GetData() const { return m_vctData; }
    //@}

private:
    vector<vector<string> > m_vctData;
};

struct SCsvReaderData;

/**
    ȃŏǂł^CvB

    ݂ȂKɂӂĎgׂB
*/
class CCsvReader {
    ImplData<SCsvReaderData> data;
    string m_strOldLine;
    List<string> m_vctCols;
public:
    CCsvReader(const CFileName& oFileName);
    ~CCsvReader();

    /// ̍sֈړBI[ɓBĂfalse
    bool ToNextLine();

    /// ڌ̎擾
    int GetCount() const { return static_cast<int>(m_vctCols.size()); }
    /// f[^̎擾
    const string& Get(int n) const { return m_vctCols[n]; }

    /// G[\ȂǗṕAPs̕
    const string& GetLine() const { return m_strOldLine; }

    //@{ i\po
    unsigned GetCurrentPos() const;
    unsigned GetSize() const;
    //@}
};

}
