/** @file
 * ONXƂB
 *
 * @author aki.
 */
#pragma once
namespace Themis {

/// O̊NXB
class Exception : public std::exception { // copyable
public:
    /// DebugWarningĝ
    static bool IsUseDebugWarning();
    /// DebugWarningĝ
    static void SetUseDebugWarning(bool b);

    virtual ~Exception() {}
    /// ̕ӂstd::exception̎MpȂȂ̂ŖIɒ`Ă
    virtual const char* what() const;

protected:
    Exception();
    Exception(const string& str);
};

/// sG[ȗOB
class RuntimeException : public Exception {
protected:
    RuntimeException() {}
public:
    RuntimeException(const string& str) : Exception(str) {}
};

/// vO~XȂǂ̗OBInvalidOprationExceptionȂǁB
class ProgramException : public Exception {
protected:
    ProgramException() {}
public:
    ProgramException(const string& str) : Exception(str) {}
};

/// WinAPIG[ԂpO
class Win32Exception : public RuntimeException {
public:
    Win32Exception(const string& str);
};

/// sȑsƂ̗O
class InvalidOprationException : public ProgramException {
protected:
    InvalidOprationException() {}
public:
    InvalidOprationException(const string& str) : ProgramException(str) {}
};

}
