#pragma once
#include "File.h"
namespace Themis {

/**
    t@Cƃf[^IuWFNg
*/
class CFileData : private boost::noncopyable {
public:
    CFileData(const CFileName& oName) : m_oName(oName) {}
    ~CFileData() {}

    const CFileName& GetName() const { return m_oName; }
    const vector<uint8_t>& GetMemory() const { return m_vctMemory; }
    vector<uint8_t>& GetMemory() { return m_vctMemory; }

private:
    CFileName       m_oName;
    vector<uint8_t>    m_vctMemory;
};

/**
    RXgN^œǂݍ݂s CFileData
*/
class CExistFileData : public CFileData {
public:
    inline CExistFileData(const CFileName& oName) : CFileData(oName) {
        CFile(GetName()).Load(GetMemory());
    }
    inline CExistFileData(CFile& rFile) : CFileData(rFile.GetName()) {
        rFile.Load(GetMemory());
    }
};

}
