#pragma once
#include "../String/Encoding.h"
namespace Themis {

/**
 * WinAPIIɃlCeBuȕB
 * NTnȂUnicodeA9xnȂCP932ƂB
 * ̃IuWFNgĂԂ̓|C^̒l͕sρB
 */
class NativeString { // ꉞcopyable
    const bool unicode;
    std::string a;
    string w;
public:
    NativeString(const string& str) : unicode(IsUnicode()) {
        operator=(str);
    }

    NativeString& operator=(const string& str) {
        if (unicode) {
            w = str;
        } else {
            a = Encoding::GetDefault().GetBytes(str);
        }
        return *this;
    }

    /// IsUnicode()ARXgN^ŌĂԂ̂Ő܊pȂ̂ŃLbVĂ݂B
    bool Unicode() const { return unicode; }

    /// Unicodeȃ|C^̎擾
    const wchar_t* GetW() const {
        BOOST_ASSERT(unicode);
        return w.ToCharPtr();
    }
    /// CP932Ƃȃ|C^̎擾
    const char* GetA() const {
        BOOST_ASSERT(!unicode);
        return a.c_str();
    }

    //@{ ev[gpȃI[o[[hB̓_~[B
    const wchar_t* Get(wchar_t) const { return GetW(); }
    const char* Get(char) const { return GetA(); }
    //@}

    /// void*Ȏ擾
    const void* GetPtr() const {
        return unicode ?
            static_cast<const void*>(GetW()) : 
            static_cast<const void*>(GetA());
    }

    /// ̎擾B
    int GetLength() const {
        return unicode ?
            w.GetLength() : 
            static_cast<int>(a.length());
    }

    /// sizeof(char)
    int GetCharSize() const { return unicode ? sizeof(wchar_t) : sizeof(char); }

    /// I[L܂܂ȂoCgԂ
    int GetBytesLength() const {
        return GetLength() * GetCharSize();
    }

/* 킵̂Ń{c
#ifdef UNICODE
    /// UNICODE}Nȃ|C^̎擾
    const wchar_t* Get() const { return GetW(); }
#else
    /// UNICODE}Nȃ|C^̎擾
    const char* Get() const { return GetA(); }
#endif
*/
    /// sNTnOSȂtrue
    static bool IsUnicode();
};

/// ANSIŁEUNICODEō\̂charTɉĐ؂ւ邽߂̃ev[gB
template<class charT, class StructA, class StructW> struct NativeStruct {};
template<class StructA, class StructW> struct NativeStruct<char, StructA, StructW> { typedef StructA T; };
template<class StructA, class StructW> struct NativeStruct<wchar_t, StructA, StructW> { typedef StructW T; };

}
